package com.sparkpoc.casetwo;

import org.apache.spark.sql.*;
import org.apache.spark.sql.streaming.StreamingQueryException;
import org.apache.spark.sql.types.StructType;

import java.util.concurrent.TimeoutException;

public class SparkConsumeFrmKafkaServiceProcessor {

    public static  void main(String args[]) throws TimeoutException, StreamingQueryException {
        SparkSession spark = SparkSession
                .builder()
                .master("local[*]")
                .appName("Java Spark Example")
                .config("spark.mongodb.input.uri","mongodb://localhost:27017")
                .getOrCreate();
        // functions.to_csv(functions.struct("*")).alias("value"))
        Dataset<Row> outPutDSFrmKafka = spark.read().format("kafka")
                //spark.select(functions.from_csv(functions.struct("*")).alias("value"))
                .option("kafka.bootstrap.servers", "localhost:9092")
                .option("subscribe", "kafkaTopicDB01")
                .option("startingOffsets", "earliest")
                .option("failOnDataLoss", "false")
                .option("maxOffsetsPerTrigger", "100")
                .load();

        if (outPutDSFrmKafka !=null) {
            StructType productStructSchema = Encoders.bean(ProductInfo.class).schema();
            //.select(functions.from_csv(functions.col("message"), productStructSchema).as("data"))
            Dataset<Row> outPutDSFrmKafkaMsg = outPutDSFrmKafka.selectExpr("CAST(value AS STRING) as message")
                    .select(functions.from_json(functions.col("message"), productStructSchema).as("data"))
                    .select("data.*");
            Dataset<Row> filteredDS = outPutDSFrmKafkaMsg.filter(functions.col("deliveryStatus").equalTo("Shipped"))
                    .filter(functions.col("timeStamp").equalTo("10-07-2023"));

            Dataset<ProductInfo> productDS = filteredDS.as(Encoders.bean(ProductInfo.class));
            // StreamingQuery streamQuery =
            // writefetchedDataToMongoDB(productDS);
            //  DataStreamWriter<ProductInfo> prodDSWriter =
            productDS.write()
                    // .format("mongodb")
                    .format("com.mongodb.spark.sql.DefaultSource")
//                .option("checkpointLocation", "/tmp/")
//                .option("forceDeleteTempCheckpointLocation", "true")
                    .option("spark.mongodb.output.uri","mongodb://localhost:27017/NisumDB.Product23June")
//                    .option("spark.mongodb.connection.uri", "localhost:27017")
//                    .option("spark.mongodb.database", "NisumDB")
//                    .option("spark.mongodb.collection", "ProductInfo")
                    .save();
// run the query
            //  StreamingQuery query = prodDSWriter.start();
//            try{
//                //streamQuery.awaitTermination();
//            }catch (Exception e){
//                e.printStackTrace();
//                // streamQuery.stop();
//                spark.stop();
//            }
        }
    }
//    private static void writefetchedDataToMongoDB(Dataset<ProductInfo> dataProduct) throws TimeoutException {
//       DataStreamWriter<ProductInfo> prodDSWriter =  dataProduct.writeStream()
//                .format("mongodb")
////                .option("checkpointLocation", "/tmp/")
////                .option("forceDeleteTempCheckpointLocation", "true")
//                .option("spark.mongodb.connection.uri", "localhost:9092")
//                .option("spark.mongodb.database", "NisumDB")
//                .option("spark.mongodb.collection", "ProductInfo")
//                .outputMode("append");
//// run the query
//        StreamingQuery query = prodDSWriter.start();
////                .format("csv")
////                .outputMode("append")
////                .trigger(org.apache.spark.sql.streaming.Trigger.ProcessingTime("10 seconds"))
////                .foreachBatch((batchDf,batchId) -> {
////                        batchDf.write().format("csv").mode("append").save("src/main/resources/productOutPutCsv");
////                })
//               // .awaitTermination();
//    }
}
