package com.sparkpoc.casetwo;

import org.apache.spark.sql.*;
import java.util.concurrent.TimeoutException;

public class SparkWriteCsvFileToKafkaController {

    public static void main(String[] args) throws TimeoutException {
        SparkSession spark = SparkSession.builder()
                .master("local[*]")
                .appName("Java Spark DB")
//                .config("spark.ui.enabled", true)
//                .config("spark.sql.shuffle.partitions", 2)
                .getOrCreate();
        Dataset<Row> ds_product = spark.read().format("csv").option("header", true)
                .load("src/main/resources/productInfo.csv");
        ds_product.show();
        if (!ds_product.isEmpty()) {
            ds_product.select(functions.to_json(functions.struct("*"))
                    .alias("value"))
                    .write()
                    .format("kafka")
                    .option("kafka.bootstrap.servers","localhost:9092")
                    .option("topic","kafkaTopicDB01")
                    .save();
        }

    }
}